Bug 1292540 - Review Request: python3-mypy - A static type checker for Python
Review Request: python3-mypy - A static type checker for Python
Status: CLOSED RAWHIDE
Product: Fedora
Classification: Fedora
Component: Package Review (Show other bugs)
rawhide
All Linux
medium Severity medium
: ---
: ---
Assigned To: Brian Lane
Fedora Extras Quality Assurance
:
Depends On: 1292539
Blocks:
  Show dependency treegraph
 
Reported: 2015-12-17 12:47 EST by David Shea
Modified: 2015-12-18 14:55 EST (History)
2 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2015-12-18 14:55:39 EST
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---
bcl: fedora‑review+


Attachments (Terms of Use)

  None (edit)
Description David Shea 2015-12-17 12:47:45 EST
Spec URL: https://dshea.fedorapeople.org/python3-mypy/python3-mypy.spec
SRPM URL: https://dshea.fedorapeople.org/python3-mypy/python3-mypy-0.2.0-1.dev20151214git.fc24.src.rpm
Description:
Mypy is an optional static type checker for Python.  You can add type
hints to your Python programs using the upcoming standard for type
annotations introduced in Python 3.5 beta 1 (PEP 484), and use mypy to
type check them statically. Find bugs in your programs without even
running them!

Fedora Account System Username: dshea
Comment 1 Brian Lane 2015-12-17 19:29:05 EST
Only 2 issues, requiring python3 and chance /usr/lib/mypy to %{prefix}/lib/mypy

Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated
[ ] = Manual review needed



===== MUST items =====

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses
     found: "PSF (v2)", "PSF (v2) MIT/X11 (BSD like)", "MIT/X11 (BSD
     like)", "Unknown or generated". 263 files have unknown license.
     Detailed output of licensecheck in
     /rust/home/bcl/tmp/1292540-python3-mypy/licensecheck.txt
[!]: Package requires other packages for directories it uses.
     Note: No known owner of /usr/lib/python3.5/site-packages,
     /usr/lib/python3.5
     Add a Requires on python3?
[ ]: Package must own all directories that it creates.
     Note: Directories without known owners: /usr/lib/python3.5/site-
     packages, /usr/lib/python3.5
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[ ]: Package contains desktop file if it is a GUI application.
[ ]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[!]: Package consistently uses macros (instead of hard-coded directory
     names).
     Need to fix /usr/lib/mypy to use %{prefix}/lib/mypy
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[ ]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[ ]: Package contains systemd file(s) if in need.
[x]: Package is not known to require an ExcludeArch tag.
[ ]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 20480 bytes in 2 files.
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least
     one supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: If (and only if) the source package includes the text of the
     license(s) in its own file, then that file, containing the text of the
     license(s) for the package is included in %license.
[x]: Package does not own files or directories owned by other packages.
[x]: All build dependencies are listed in BuildRequires, except for any
     that are listed in the exceptions section of Packaging Guidelines.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Dist tag is present.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package use %makeinstall only when make install DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package does not use a name that already exists.
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as
     provided in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

Python:
[x]: Python eggs must not download any dependencies during the build
     process.
[ ]: A package which is used by another package via an egg interface should
     provide egg info.
[x]: Package meets the Packaging Guidelines::Python
[x]: Package contains BR: python2-devel or python3-devel
[x]: Binary eggs must be removed in %prep

===== SHOULD items =====

Generic:
[ ]: If the source package does not include license text(s) as a separate
     file from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[x]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[x]: Patches link to upstream bugs/comments/lists or are otherwise
     justified.
[x]: SourceX tarball generation or download is documented.
     Note: Package contains tarball without URL, check comments
[ ]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[ ]: %check is present and all tests pass.
[ ]: Packages should try to preserve timestamps of original installed
     files.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[x]: Rpmlint is run on all installed packages.
     Note: No rpmlint messages.
[x]: Spec file according to URL is the same as in SRPM.


Rpmlint
-------
Checking: python3-mypy-0.2.0-1.dev20151214git.fc24.noarch.rpm
          python3-mypy-0.2.0-1.dev20151214git.fc24.src.rpm
python3-mypy.src:72: E: hardcoded-library-path in /usr/lib/mypy
python3-mypy.src: W: invalid-url Source0: mypy-0.2.0-2f760a.tar.gz
2 packages and 0 specfiles checked; 1 errors, 1 warnings.




Rpmlint
-------
Checking: python3-mypy-0.2.0-1.dev20151214git.fc24.noarch.rpm
          python3-mypy-0.2.0-1.dev20151214git.fc24.src.rpm
python3-mypy.src:72: E: hardcoded-library-path in /usr/lib/mypy
python3-mypy.src: W: invalid-url Source0: mypy-0.2.0-2f760a.tar.gz
2 packages and 0 specfiles checked; 1 errors, 1 warnings.




Rpmlint (installed packages)
----------------------------
sh: /usr/bin/python: No such file or directory
1 packages and 0 specfiles checked; 0 errors, 0 warnings.

NOTE: No idea where the above comes from. Installed files do not have /usr/bin/python present.

Requires
--------
python3-mypy (rpmlib, GLIBC filtered):
    /usr/bin/python3
    python(abi)
    python-typeshed



Provides
--------
python3-mypy:
    python3-mypy



Generated by fedora-review 0.6.0 (3c5c9d7) last change: 2015-05-20
Command line :/usr/bin/fedora-review -b 1292540
Buildroot used: fedora-rawhide-x86_64
Active plugins: Python, Generic, Shell-api
Disabled plugins: Java, C/C++, fonts, SugarActivity, Ocaml, Perl, Haskell, R, PHP, Ruby
Disabled flags: EXARCH, DISTTAG, EPEL5, BATCH, EPEL6
Comment 2 David Shea 2015-12-18 07:49:48 EST
Spec URL: https://dshea.fedorapeople.org/python3-mypy/python3-mypy.spec
SRPM URL: https://dshea.fedorapeople.org/python3-mypy/python3-mypy-0.2.0-1.dev20151217git.fc24.src.rpm

Changed /usr to %{_prefix} and updated to the latest upstream, which includes the patch for stubgen --help that was in the original SRPM.

I assume the /usr/bin/python thing from rpmlint is a rpmlint bug. It's probably trying to run some python code as part of the python-specific rpm checking, but since this package is python3-only nothing pulled in /usr/bin/python.

The thing about adding a requires for python3, I have no clue what is going on. python(abi) (= 3.5, presumably) and /usr/bin/python3 are in the --requires output as expected, so it already does require python3. I realized that I had forgotten to add the %python_provide macro to the spec file, so I did that and I'm hoping that takes care of whatever fedora-review or mock or whatever is expecting.
Comment 3 Brian Lane 2015-12-18 11:39:16 EST
It is still complaining about %{_prefix}/lib/mypy but after looking at other packages it appears this is a perfectly valid way to reference it so I'm going to say pass. I have no idea what fedora-review expects there.
Comment 4 Gwyn Ciesla 2015-12-18 14:00:00 EST
Package request has been approved: https://admin.fedoraproject.org/pkgdb/package/python3-mypy

Note You need to log in before you can comment on or make changes to this bug.